<?php

/**
 * Class TwoFAApi
 */
class TwoFAApi
{
    const BASE_URL = 'https://www.afilnet.com/api/http/';
    protected $class, $method;
    protected $user, $password;
    protected $otp;

    /**
     * TwoFAApi constructor.
     */
    function __construct()
    {
        $credentials = TwoFASettings::get_settings('credentials');
        $this->user = $credentials['user'];
        $this->password = $credentials['password'];
    }

    /**
     * @return string
     * @throws Exception
     */
    function getBalance()
    {
        $this->class = 'user';
        $this->method = 'getbalance';
        $result = file_get_contents(self::BASE_URL . "?class=" . $this->class . "&method=" . $this->method . "&user=" . $this->user . "&password=" . $this->password);
        $response = json_decode($result);
        if ($response->status === 'SUCCESS') {
            return $response->result;
        } else {
            throw new Exception($response->error);
        }
    }

    /**
     * @param string $phone
     * @return string
     * @throws Exception
     */
    function generateOTP($phone)
    {
        $this->class = 'otp';
        $this->method = 'generateotp';
        $type = "number";
        $destination = $phone;
        $time = 1;
        $timetype = "days";
        $length = 6;
        $otpformat = 'all';
        $output = "";
        $result = file_get_contents("https://www.afilnet.com/api/http/?class=" . $this->class . "&method=" . $this->method . "&user=" . $this->user . "&password=" . $this->password . "&type=" . $type . "&destination=" . $destination . "&time=" . $time . "&timetype=" . $timetype . "&length=" . $length . "&otpformat=" . $otpformat . "&output=" . $output);
        $response = json_decode($result);
        if ($response->status === 'SUCCESS') {
            return $response->result->code;
        } else {
            throw new Exception($response->error);
        }
    }

    /**
     * @param string $phone
     * @param string $otp
     * @return bool
     */
    function verifyOTP($phone, $otp)
    {
        $this->class = 'otp';
        $this->method = 'verifyotp';
        $destination = $phone;
        $code = $otp;
        $output = "";
        $result = file_get_contents("https://www.afilnet.com/api/http/?class=" . $this->class . "&method=" . $this->method . "&user=" . $this->user . "&password=" . $this->password . "&destination=" . $destination . "&code=" . $code . "&output=" . $output);
        $response = json_decode($result);
        if ($response->status === 'SUCCESS') {
            return true;
        } else {
            return false;
        }
    }

    /**
     * @param string $phone
     * @param string $otp
     * @return String
     * @throws Exception
     */
    function sendSMS($phone, $otp)
    {
        $this->class = 'sms';
        $this->method = 'sendsms';
        $from = get_bloginfo('name');
        $to = $phone;
        $sms = "Your OTP for " . get_bloginfo('name') . " is " . $otp;
        $scheduledatetime = "";
        $output = "";
        $result = file_get_contents("https://www.afilnet.com/api/http/?class=" . $this->class . "&method=" . $this->method . "&user=" . $this->user . "&password=" . $this->password . "&from=" . urlencode($from) . "&to=" . $to . "&sms=" . urlencode($sms) . "&scheduledatetime=" . $scheduledatetime . "&output=" . $output);
        $response = json_decode($result);
        if ($response->status === 'SUCCESS') {
            return $response->result->messageid;
        } else {
            throw new Exception($response->error);
        }
    }
}