<?php
function check_twofa_on_login($user_login, $user)
{
    //This here function is an additional layer of security that checks if the user have completed the Two Factor authentication correctly.
    //Cannot display any error messages in login page from here, that's why the otp is checked from frontend and confirmed again here.
    $processes = new TwoFAProcesses();
    $twofa_activated = $processes->userHasTwoFAEnabled($user->ID);
    if ($twofa_activated) {
        //Here the saved otp is deleted so that it won't be used again.
        $savedOTP = $processes->getUserOTP($user->ID, true);
        if ($_POST['otp'] != $savedOTP || !$processes->verifyOTPSecurityCode($_POST['otp-security-code'], $_POST['otp'])) {
            //Something fishy is going on here. If all went well, this shouldn't happen. You can't be too careful.
            //Logout the current user forcefully to try again.
            wp_logout();
        }
    }
}

add_action('wp_login', 'check_twofa_on_login', 10, 2);

function enqueue_my_script($page)
{
    wp_enqueue_script('twofa-script', TwoFA_PLUGIN_URL . 'js/twofa-login.js', array('jquery'), null, true);
    $localize = array(
        'ajaxURL' => admin_url('admin-ajax.php'),
        'nonce' => wp_create_nonce('twofa-login-script-nonce')
    );
    wp_localize_script('twofa-script', 'TwoFAAjax', $localize);
}

add_action('login_enqueue_scripts', 'enqueue_my_script');